(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('@angular/forms'), require('@angular/common'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('angular-tree-grid', ['exports', 'rxjs', '@angular/forms', '@angular/common', '@angular/core'], factory) :
    (factory((global['angular-tree-grid'] = {}),global.rxjs,global.ng.forms,global.ng.common,global.ng.core));
}(this, (function (exports,rxjs,forms,common,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/angular-tree-grid.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularTreeGridService = /** @class */ (function () {
        function AngularTreeGridService() {
            this.display_data_observable = new rxjs.Subject();
            this.display_data_observable$ = this.display_data_observable.asObservable();
        }
        /**
         * @param {?} display_data
         * @return {?}
         */
        AngularTreeGridService.prototype.updateDisplayDataObservable = /**
         * @param {?} display_data
         * @return {?}
         */
            function (display_data) {
                this.display_data_observable.next(display_data);
            };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.findRowIndex = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
            function (display_data, configs, row_id) {
                return display_data.map(( /**
                 * @param {?} row
                 * @return {?}
                 */function (row) { return row[configs.id_field]; })).
                    indexOf(row_id);
            };
        /**
         * @param {?} display_data
         * @return {?}
         */
        AngularTreeGridService.prototype.selectAll = /**
         * @param {?} display_data
         * @return {?}
         */
            function (display_data) {
                display_data.forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    data.row_selected = true;
                }));
            };
        /**
         * @param {?} display_data
         * @return {?}
         */
        AngularTreeGridService.prototype.deSelectAll = /**
         * @param {?} display_data
         * @return {?}
         */
            function (display_data) {
                display_data.forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    data.row_selected = false;
                }));
            };
        /**
         * @param {?} expand_tracker
         * @return {?}
         */
        AngularTreeGridService.prototype.expandAll = /**
         * @param {?} expand_tracker
         * @return {?}
         */
            function (expand_tracker) {
                for (var key in expand_tracker) {
                    if (expand_tracker.hasOwnProperty(key)) {
                        expand_tracker[key] = true;
                    }
                }
            };
        /**
         * @param {?} expand_tracker
         * @return {?}
         */
        AngularTreeGridService.prototype.collapseAll = /**
         * @param {?} expand_tracker
         * @return {?}
         */
            function (expand_tracker) {
                for (var key in expand_tracker) {
                    if (expand_tracker.hasOwnProperty(key)) {
                        expand_tracker[key] = false;
                    }
                }
                expand_tracker[''] = true;
            };
        /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} expand_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @param {?} store
         * @return {?}
         */
        AngularTreeGridService.prototype.expandRow = /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} expand_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @param {?} store
         * @return {?}
         */
            function (row_id, expand_tracker, expand_event, suppress_event, configs, display_data, store) {
                if (configs.subgrid) {
                    this.expandSubgridRow(row_id, expand_tracker, expand_event, suppress_event, configs, display_data, store);
                    return;
                }
                /** @type {?} */
                var row_index = this.findRowIndex(display_data, configs, row_id);
                /** @type {?} */
                var row_data = display_data[row_index];
                /** @type {?} */
                var pathx = row_data.pathx;
                /** @type {?} */
                var parts = pathx.split('.');
                expand_tracker[row_data.pathx] = true;
                /** @type {?} */
                var expanded_count = 1;
                for (var index = 0; index < display_data.length; index++) {
                    /** @type {?} */
                    var record = display_data[index];
                    // Stop when all rows are expanded.
                    if (expanded_count >= parts.length) {
                        return;
                    }
                    // Join paths as we expand.
                    /** @type {?} */
                    var key = parts.slice(0, expanded_count).join('.');
                    // We don't want to expand it's children here.
                    if (record.pathx.indexOf(key) !== -1) {
                        expanded_count += 1;
                        expand_tracker[record.pathx] = true;
                        if (!suppress_event) {
                            if (configs.load_children_on_expand) {
                                this.emitExpandRowEvent(expand_tracker, expand_event, store, row_data, configs);
                            }
                            else {
                                expand_event.emit({ event: null, data: row_data });
                            }
                        }
                    }
                }
            };
        /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} collapse_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @return {?}
         */
        AngularTreeGridService.prototype.collapseRow = /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} collapse_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @return {?}
         */
            function (row_id, expand_tracker, collapse_event, suppress_event, configs, display_data) {
                /** @type {?} */
                var row_index = this.findRowIndex(display_data, configs, row_id);
                /** @type {?} */
                var row_data = display_data[row_index];
                /** @type {?} */
                var pathx = row_data.pathx;
                expand_tracker[pathx] = false;
                // Collapse children rows as well
                display_data.forEach(( /**
                 * @param {?} record
                 * @return {?}
                 */function (record) {
                    if (record.pathx.indexOf(pathx) !== -1) {
                        expand_tracker[record.pathx] = 0;
                        if (!suppress_event) {
                            collapse_event.emit({ event: null, data: row_data });
                        }
                    }
                }));
            };
        /**
         * @param {?} expand_tracker
         * @param {?} expand
         * @param {?} store
         * @param {?} row_data
         * @param {?} configs
         * @return {?}
         */
        AngularTreeGridService.prototype.emitExpandRowEvent = /**
         * @param {?} expand_tracker
         * @param {?} expand
         * @param {?} store
         * @param {?} row_data
         * @param {?} configs
         * @return {?}
         */
            function (expand_tracker, expand, store, row_data, configs) {
                /** @type {?} */
                var promise = new Promise(( /**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */function (resolve, reject) {
                    expand.emit({
                        data: row_data,
                        resolve: resolve
                    });
                }));
                expand_tracker[row_data.pathx] = true;
                store.remove_children(row_data);
                row_data.is_loading = true;
                // Add Child rows to the table.
                promise.then(( /**
                 * @param {?} child_rows
                 * @return {?}
                 */function (child_rows) {
                    row_data.is_loading = false;
                    store.remove_children(row_data);
                    if (child_rows) {
                        child_rows.map(( /**
                         * @param {?} child
                         * @return {?}
                         */function (child) {
                            child.leaf = true;
                            child.levelx = row_data.levelx + 1;
                            child.pathx = row_data.pathx + '.' + child[configs.id_field];
                            child.parent_pathx = row_data.pathx;
                            child[configs.parent_id_field] = row_data[configs.id_field];
                        }));
                        store.add_children(row_data, child_rows);
                    }
                })).catch(( /**
                 * @param {?} err
                 * @return {?}
                 */function (err) { }));
            };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.disableRowSelection = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
            function (display_data, configs, row_id) {
                /** @type {?} */
                var row_index = this.findRowIndex(display_data, configs, row_id);
                display_data[row_index].selection_disabled = true;
            };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.enableRowSelection = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
            function (display_data, configs, row_id) {
                /** @type {?} */
                var row_index = this.findRowIndex(display_data, configs, row_id);
                display_data[row_index].selection_disabled = false;
            };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.disableRowExpand = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
            function (display_data, configs, row_id) {
                /** @type {?} */
                var row_index = this.findRowIndex(display_data, configs, row_id);
                display_data[row_index].expand_disabled = true;
            };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.enableRowExpand = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
            function (display_data, configs, row_id) {
                /** @type {?} */
                var row_index = this.findRowIndex(display_data, configs, row_id);
                display_data[row_index].expand_disabled = false;
            };
        /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} expand_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @param {?} store
         * @return {?}
         */
        AngularTreeGridService.prototype.expandSubgridRow = /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} expand_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @param {?} store
         * @return {?}
         */
            function (row_id, expand_tracker, expand_event, suppress_event, configs, display_data, store) {
                /** @type {?} */
                var row_index = this.findRowIndex(display_data, configs, row_id);
                /** @type {?} */
                var row_data = display_data[row_index];
                expand_tracker[row_data.pathx] = true;
                if (!suppress_event) {
                    this.emitSubgridExpandRowEvent(expand_tracker, expand_event, store, row_data);
                }
            };
        /**
         * @param {?} expand_tracker
         * @param {?} expand
         * @param {?} store
         * @param {?} row_data
         * @return {?}
         */
        AngularTreeGridService.prototype.emitSubgridExpandRowEvent = /**
         * @param {?} expand_tracker
         * @param {?} expand
         * @param {?} store
         * @param {?} row_data
         * @return {?}
         */
            function (expand_tracker, expand, store, row_data) {
                /** @type {?} */
                var promise = new Promise(( /**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */function (resolve, reject) {
                    expand.emit({
                        data: row_data,
                        resolve: resolve
                    });
                }));
                expand_tracker[row_data.pathx] = true;
                /** @type {?} */
                var blank_row = store.showBlankRow(row_data);
                blank_row.loading_children = true;
                // Add Child rows to the table.
                promise.then(( /**
                 * @param {?} child_rows
                 * @return {?}
                 */function (child_rows) {
                    blank_row.loading_children = false;
                    if (child_rows) {
                        child_rows.map(( /**
                         * @param {?} child
                         * @return {?}
                         */function (child) {
                            child.leaf = true;
                        }));
                        blank_row.children = child_rows;
                    }
                    else {
                        // Persist old children. If didn't exist then assign blank array.
                        if (!blank_row.children) {
                            blank_row.children = [];
                        }
                    }
                })).catch(( /**
                 * @param {?} err
                 * @return {?}
                 */function (err) { }));
            };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.selectRow = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
            function (display_data, configs, row_id) {
                this.deSelectAll(display_data);
                /** @type {?} */
                var row_index = this.findRowIndex(display_data, configs, row_id);
                display_data[row_index].row_selected = true;
            };
        AngularTreeGridService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        AngularTreeGridService.ctorParameters = function () { return []; };
        /** @nocollapse */ AngularTreeGridService.ngInjectableDef = i0.defineInjectable({ factory: function AngularTreeGridService_Factory() { return new AngularTreeGridService(); }, token: AngularTreeGridService, providedIn: "root" });
        return AngularTreeGridService;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/store/store.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Store = /** @class */ (function () {
        function Store(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
        }
        /**
         * @return {?}
         */
        Store.prototype.getRawData = /**
         * @return {?}
         */
            function () {
                return this.raw_data;
            };
        /**
         * @param {?} raw_data
         * @return {?}
         */
        Store.prototype.setRawData = /**
         * @param {?} raw_data
         * @return {?}
         */
            function (raw_data) {
                this.raw_data = raw_data;
            };
        /**
         * @return {?}
         */
        Store.prototype.getProcessedData = /**
         * @return {?}
         */
            function () {
                return this.processed_data;
            };
        /**
         * @param {?} processed_data
         * @return {?}
         */
        Store.prototype.setProcessedData = /**
         * @param {?} processed_data
         * @return {?}
         */
            function (processed_data) {
                this.processed_data = processed_data;
                this.setDisplayData(__spread(processed_data));
            };
        /**
         * @return {?}
         */
        Store.prototype.getDisplayData = /**
         * @return {?}
         */
            function () {
                return this.display_data;
            };
        /**
         * @param {?} display_data
         * @return {?}
         */
        Store.prototype.setDisplayData = /**
         * @param {?} display_data
         * @return {?}
         */
            function (display_data) {
                this.display_data = display_data;
                this.angularTreeGridService.updateDisplayDataObservable(this.display_data);
            };
        /**
         * Show Blank row for subgrid.
         *
         * @param  row_data Row Data
         * @returns blank_row
         */
        /**
         * Show Blank row for subgrid.
         *
         * @param {?} row_data Row Data
         * @return {?} blank_row
         */
        Store.prototype.showBlankRow = /**
         * Show Blank row for subgrid.
         *
         * @param {?} row_data Row Data
         * @return {?} blank_row
         */
            function (row_data) {
                var _this = this;
                /** @type {?} */
                var row_index = this.display_data.map(( /**
                 * @param {?} row
                 * @return {?}
                 */function (row) { return row[_this.configs.id_field]; })).
                    indexOf(row_data[this.configs.id_field]);
                /** @type {?} */
                var blank_row = this.display_data[row_index + 1];
                if (!blank_row || blank_row.parent_pathx !== row_data[this.configs.id_field]) {
                    blank_row = {
                        leaf: true,
                        row_selected: true,
                        // By default make it selected as it's never going to be selected manually.
                        parent_pathx: row_data[this.configs.id_field]
                    };
                    blank_row[this.configs.id_field] = -1;
                    this.display_data.splice(row_index + 1, 0, blank_row);
                }
                return blank_row;
            };
        /**
         * @param {?} row_data
         * @return {?}
         */
        Store.prototype.remove_children = /**
         * @param {?} row_data
         * @return {?}
         */
            function (row_data) {
                /** @type {?} */
                var new_processed_data = [];
                for (var index = 0; index < this.processed_data.length; index++) {
                    /** @type {?} */
                    var element = this.processed_data[index];
                    if (element[this.configs.parent_id_field] !== row_data[this.configs.id_field]) {
                        new_processed_data.push(element);
                    }
                }
                this.setProcessedData(new_processed_data);
            };
        /**
         * @param {?} row_data
         * @param {?} children
         * @return {?}
         */
        Store.prototype.add_children = /**
         * @param {?} row_data
         * @param {?} children
         * @return {?}
         */
            function (row_data, children) {
                var _this = this;
                /** @type {?} */
                var row_index = this.processed_data.map(( /**
                 * @param {?} row
                 * @return {?}
                 */function (row) { return row[_this.configs.id_field]; })).
                    indexOf(row_data[this.configs.id_field]);
                /** @type {?} */
                var top_rows = this.processed_data.slice(0, row_index + 1);
                /** @type {?} */
                var bottom_rows = this.processed_data.slice(row_index + 1);
                this.processed_data = top_rows.concat(children).concat(bottom_rows);
                this.setDisplayData(__spread(this.processed_data));
                this.angularTreeGridService.updateDisplayDataObservable(this.display_data);
            };
        /**
         * @param {?} columns
         * @param {?} search_values
         * @return {?}
         */
        Store.prototype.filterBy = /**
         * @param {?} columns
         * @param {?} search_values
         * @return {?}
         */
            function (columns, search_values) {
                this.display_data = this.processed_data.filter(( /**
                 * @param {?} record
                 * @return {?}
                 */function (record) {
                    /** @type {?} */
                    var found = true;
                    for (var index = 0; index < columns.length; index++) {
                        /** @type {?} */
                        var column = columns[index];
                        /** @type {?} */
                        var column_value = record[column.name];
                        /** @type {?} */
                        var search_value = search_values[index];
                        // If blank then continue.
                        if (!search_value) {
                            continue;
                        }
                        // Call custom filter function.
                        if (column.filter_function) {
                            /** @type {?} */
                            var response = column.filter_function(record, column, column_value, search_value);
                            if (response === false) {
                                found = false;
                            }
                        }
                        else {
                            if (typeof (column_value) === 'number') {
                                if (column_value !== parseInt(search_value, 10)) {
                                    found = false;
                                }
                            }
                            else {
                                if (!column.case_sensitive_filter) {
                                    column_value = column_value.toLowerCase();
                                    search_value = search_value.toLowerCase();
                                }
                                if (column_value.indexOf(search_value) === -1) {
                                    found = false;
                                }
                            }
                        }
                    }
                    return found;
                }));
                this.angularTreeGridService.updateDisplayDataObservable(this.display_data);
            };
        /**
         * @param {?} data
         * @param {?} configs
         * @return {?}
         */
        Store.prototype.findTopParentNode = /**
         * @param {?} data
         * @param {?} configs
         * @return {?}
         */
            function (data, configs) {
                /** @type {?} */
                var ids = data.map(( /**
                 * @param {?} element
                 * @return {?}
                 */function (element) { return element[configs.id_field]; }));
                /** @type {?} */
                var top_parents = [];
                // Find parents ie if parent_id is not present in ids.
                data.forEach(( /**
                 * @param {?} element
                 * @return {?}
                 */function (element) {
                    if (ids.indexOf(element[configs.parent_id_field]) === -1) {
                        top_parents.push(element[configs.parent_id_field]);
                    }
                }));
                // Remove duplicates
                top_parents = top_parents.filter(( /**
                 * @param {?} item
                 * @param {?} pos
                 * @param {?} self
                 * @return {?}
                 */function (item, pos, self) {
                    return self.indexOf(item) === pos;
                }));
                return top_parents;
            };
        /**
         * @param {?} data
         * @param {?} expand_tracker
         * @param {?} configs
         * @param {?} edit_tracker
         * @param {?} internal_configs
         * @return {?}
         */
        Store.prototype.processData = /**
         * @param {?} data
         * @param {?} expand_tracker
         * @param {?} configs
         * @param {?} edit_tracker
         * @param {?} internal_configs
         * @return {?}
         */
            function (data, expand_tracker, configs, edit_tracker, internal_configs) {
                var _this = this;
                /** @type {?} */
                var top_parents = this.findTopParentNode(data, configs);
                /** @type {?} */
                var processed_data = [];
                internal_configs.top_parents = top_parents;
                data.map(( /**
                 * @param {?} rec
                 * @return {?}
                 */function (rec) {
                    rec.pathx = [];
                    rec.leaf = false;
                }));
                top_parents.forEach(( /**
                 * @param {?} top_parent
                 * @return {?}
                 */function (top_parent) {
                    /** @type {?} */
                    var children = _this.findChildren(data, top_parent, configs);
                    _this.orderData(data, processed_data, configs, children, [], 0);
                }));
                processed_data.map(( /**
                 * @param {?} rec
                 * @return {?}
                 */function (rec) {
                    /** @type {?} */
                    var parent_pathx = rec.parent_pathx;
                    rec.parent_pathx = parent_pathx.join('.');
                    parent_pathx.push(rec[configs.id_field]);
                    // Add current id to create current path.
                    rec.pathx = parent_pathx.join('.');
                    expand_tracker[rec.pathx] = false;
                    edit_tracker[rec[configs.id_field]] = false;
                    // For Subgrid feature, expect all rows are expandable.
                    if (configs.subgrid) {
                        rec.leaf = false;
                    }
                }));
                // Expand root.
                expand_tracker[''] = true;
                this.setProcessedData(processed_data);
                this.setRawData(data);
                this.configs = configs;
            };
        /**
         * @param {?} data
         * @param {?} id
         * @param {?} configs
         * @return {?}
         */
        Store.prototype.findChildren = /**
         * @param {?} data
         * @param {?} id
         * @param {?} configs
         * @return {?}
         */
            function (data, id, configs) {
                return data.filter(( /**
                 * @param {?} rec
                 * @return {?}
                 */function (rec) { return rec[configs.parent_id_field] === id; }));
            };
        /**
         * @param {?} data
         * @param {?} processed_data
         * @param {?} configs
         * @param {?} parents
         * @param {?} paths
         * @param {?} levelx
         * @return {?}
         */
        Store.prototype.orderData = /**
         * @param {?} data
         * @param {?} processed_data
         * @param {?} configs
         * @param {?} parents
         * @param {?} paths
         * @param {?} levelx
         * @return {?}
         */
            function (data, processed_data, configs, parents, paths, levelx) {
                var _this = this;
                parents.forEach(( /**
                 * @param {?} parent
                 * @return {?}
                 */function (parent) {
                    /** @type {?} */
                    var children = _this.findChildren(data, parent[configs.id_field], configs);
                    if (children.length === 0) {
                        parent.leaf = true;
                        parent.levelx = levelx;
                        parent.parent_pathx = __spread(paths);
                        processed_data.push(parent);
                    }
                    else {
                        parent.parent_pathx = __spread(paths);
                        parent.levelx = levelx;
                        processed_data.push(parent);
                        /** @type {?} */
                        var newPaths = __spread(paths, [parent[configs.id_field]]);
                        _this.orderData(data, processed_data, configs, children, newPaths, levelx + 1);
                    }
                }));
            };
        /**
         * @return {?}
         */
        Store.prototype.refreshDisplayData = /**
         * @return {?}
         */
            function () {
                this.display_data = this.processed_data;
                this.angularTreeGridService.updateDisplayDataObservable(this.display_data);
            };
        return Store;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/angular-tree-grid.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularTreeGridComponent = /** @class */ (function () {
        function AngularTreeGridComponent(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
            this.processed_data = [];
            this.expand_tracker = {};
            this.columns = [];
            this.edit_tracker = {}; // Track Edit options.
            // Track Edit options.
            this.internal_configs = {
                show_add_row: false,
                show_parent_col: false,
                all_selected: false
            };
            this.store = new Store(this.angularTreeGridService);
            this.default_configs = {
                css: {
                    expand_class: 'plus',
                    collapse_class: 'minus',
                    add_class: 'plus',
                    edit_class: '',
                    delete_class: '',
                    save_class: '',
                    cancel_class: '',
                    row_selection_class: 'selected',
                    header_class: '',
                    row_filter_class: '',
                    table_class: ''
                },
                actions: {
                    edit: false,
                    add: false,
                    delete: false,
                    resolve_edit: false,
                    resolve_add: false,
                    resolve_delete: false,
                    edit_parent: false
                },
                data_loading_text: 'Loading...',
                filter: false,
                multi_select: false,
                show_parent_on_edit: true,
                show_summary_row: false,
                subgrid: false,
                load_children_on_expand: false,
                action_column_width: '60px',
                action_column_position: 'first',
                action_column_text: 'Actions',
                row_class_function: ( /**
                 * @return {?}
                 */function () { return true; }),
                row_edit_function: ( /**
                 * @return {?}
                 */function () { return true; }),
                row_delete_function: ( /**
                 * @return {?}
                 */function () { return true; }),
                subgrid_config: {
                    show_summary_row: false,
                    data_loading_text: 'Loading...'
                }
            };
            this.default_column_config = {
                sorted: 0,
                sort_type: null,
                editable: false,
                hidden: false,
                filter: true,
                case_sensitive_filter: false
            };
            this.cellclick = new i0.EventEmitter();
            this.expand = new i0.EventEmitter();
            this.collapse = new i0.EventEmitter();
            this.rowselect = new i0.EventEmitter();
            this.rowdeselect = new i0.EventEmitter();
            this.rowselectall = new i0.EventEmitter();
            this.rowdeselectall = new i0.EventEmitter();
            this.rowadd = new i0.EventEmitter();
            this.rowsave = new i0.EventEmitter();
            this.rowdelete = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (!this.validateConfigs()) {
                    return;
                }
                this.setDefaultConfigs();
                this.setColumnNames();
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                if (!this.validateConfigs()) {
                    return;
                }
                this.setDefaultConfigs();
                this.setColumnNames();
                this.store.processData(this.data, this.expand_tracker, this.configs, this.edit_tracker, this.internal_configs);
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.validateConfigs = /**
         * @return {?}
         */
            function () {
                if (!this.data) {
                    window.console.warn('data can\'t be empty!');
                    return;
                }
                if (!this.configs) {
                    window.console.warn('configs can\'t be empty!');
                    return;
                }
                /** @type {?} */
                var element = this.data[0];
                /** @type {?} */
                var isValidated = true;
                if (!this.configs.id_field) {
                    isValidated = false;
                    window.console.error('id field is mandatory!');
                }
                if (!this.configs.parent_id_field && !this.configs.subgrid) {
                    isValidated = false;
                    window.console.error('parent_id field is mandatory!');
                }
                if (element && !element.hasOwnProperty(this.configs.id_field)) {
                    isValidated = false;
                    console.error('id_field doesn\'t exist!');
                }
                if (element && !element.hasOwnProperty(this.configs.parent_id_field)
                    && !this.configs.subgrid
                    && !this.configs.load_children_on_expand) {
                    isValidated = false;
                    console.error('parent_id_field doesn\'t exist!');
                }
                if (element && !element.hasOwnProperty(this.configs.parent_display_field)) {
                    isValidated = false;
                    console.error('parent_display_field doesn\'t exist! Basically this field will be expanded.');
                }
                if (this.configs.subgrid && !this.configs.subgrid_config) {
                    isValidated = false;
                    console.error('subgrid_config doesn\'t exist!');
                }
                if (this.configs.subgrid && this.configs.subgrid_config && !this.configs.subgrid_config.id_field) {
                    isValidated = false;
                    console.error('id_field of subgrid doesn\'t exist!');
                }
                if (this.configs.subgrid && this.configs.subgrid_config && !this.configs.subgrid_config.columns) {
                    isValidated = false;
                    console.error('columns of subgrid doesn\'t exist!');
                }
                return isValidated;
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.setDefaultConfigs = /**
         * @return {?}
         */
            function () {
                this.processed_data = [];
                this.configs = Object.assign({}, this.default_configs, this.configs);
                // Deep clone.
                this.configs.actions = Object.assign({}, this.default_configs.actions, this.configs.actions);
                this.configs.css = Object.assign({}, this.default_configs.css, this.configs.css);
                this.configs.subgrid_config = Object.assign({}, this.default_configs.subgrid_config, this.configs.subgrid_config);
                if (this.configs.subgrid) {
                    this.configs.actions.add = false;
                }
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.setColumnNames = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.columns = this.configs.columns ? this.configs.columns : [];
                // If columns doesn't exist in user's object.
                if (!this.configs.columns) {
                    /** @type {?} */
                    var column_keys = Object.keys(this.data[0]);
                    // Insert Header and default configuration.
                    column_keys.forEach(( /**
                     * @param {?} key
                     * @return {?}
                     */function (key) {
                        _this.columns.push(Object.assign({ 'header': key, 'name': key }, _this.default_column_config));
                    }));
                }
                else {
                    // Insert Header and default configuration.
                    for (var i = 0; i < this.columns.length; i++) {
                        this.columns[i] = Object.assign({}, this.default_column_config, this.columns[i]);
                    }
                }
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.collapseAll = /**
         * @return {?}
         */
            function () {
                this.angularTreeGridService.collapseAll(this.expand_tracker);
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.expandAll = /**
         * @return {?}
         */
            function () {
                this.angularTreeGridService.expandAll(this.expand_tracker);
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.selectAll = /**
         * @return {?}
         */
            function () {
                this.angularTreeGridService.selectAll(this.store.getDisplayData());
                this.internal_configs.all_selected = true;
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.deSelectAll = /**
         * @return {?}
         */
            function () {
                this.angularTreeGridService.deSelectAll(this.store.getDisplayData());
                this.internal_configs.all_selected = false;
            };
        /**
         * @param {?} row_id
         * @param {?=} suppress_event
         * @return {?}
         */
        AngularTreeGridComponent.prototype.expandRow = /**
         * @param {?} row_id
         * @param {?=} suppress_event
         * @return {?}
         */
            function (row_id, suppress_event) {
                this.angularTreeGridService.expandRow(row_id, this.expand_tracker, this.expand, suppress_event, this.configs, this.store.getDisplayData(), this.store);
            };
        /**
         * @param {?} row_id
         * @param {?=} suppress_event
         * @return {?}
         */
        AngularTreeGridComponent.prototype.collapseRow = /**
         * @param {?} row_id
         * @param {?=} suppress_event
         * @return {?}
         */
            function (row_id, suppress_event) {
                this.angularTreeGridService.collapseRow(row_id, this.expand_tracker, this.collapse, suppress_event, this.configs, this.store.getDisplayData());
            };
        /**
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridComponent.prototype.disableRowSelection = /**
         * @param {?} row_id
         * @return {?}
         */
            function (row_id) {
                this.angularTreeGridService.disableRowSelection(this.store.getDisplayData(), this.configs, row_id);
            };
        /**
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridComponent.prototype.enableRowSelection = /**
         * @param {?} row_id
         * @return {?}
         */
            function (row_id) {
                this.angularTreeGridService.enableRowSelection(this.store.getDisplayData(), this.configs, row_id);
            };
        /**
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridComponent.prototype.disableRowExpand = /**
         * @param {?} row_id
         * @return {?}
         */
            function (row_id) {
                this.angularTreeGridService.disableRowExpand(this.store.getDisplayData(), this.configs, row_id);
            };
        /**
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridComponent.prototype.enableRowExpand = /**
         * @param {?} row_id
         * @return {?}
         */
            function (row_id) {
                this.angularTreeGridService.enableRowExpand(this.store.getDisplayData(), this.configs, row_id);
            };
        /**
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridComponent.prototype.selectRow = /**
         * @param {?} row_id
         * @return {?}
         */
            function (row_id) {
                this.angularTreeGridService.selectRow(this.store.getDisplayData(), this.configs, row_id);
            };
        AngularTreeGridComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-angular-tree-grid',
                        template: "<table [attr.class]=\"'db-tree-view ' + configs.css.table_class\" >\n    <thead \n        db-tree-head\n        [store]=\"store\"\n        [expand_tracker]=\"expand_tracker\"\n        [internal_configs]=\"internal_configs\"\n        [edit_tracker]=\"edit_tracker\"\n        [rowselectall]=\"rowselectall\"\n        [rowdeselectall]=\"rowdeselectall\"\n        [columns]=\"columns\"\n        [configs]=\"configs\">\n    </thead>\n\n    <tbody \n        db-tree-body\n        [store]=\"store\"\n        [expand_tracker]=\"expand_tracker\"\n        [edit_tracker]=\"edit_tracker\"\n        [internal_configs]=\"internal_configs\"\n        [columns]=\"columns\"\n        [configs]=\"configs\"\n        [cellclick]=\"cellclick\"\n        [expand]=\"expand\"\n        [collapse]=\"collapse\"\n        [rowdelete]=\"rowdelete\"\n        [rowsave]=\"rowsave\"\n        [rowadd]=\"rowadd\"\n        [rowselect]=\"rowselect\"\n        [rowdeselect]=\"rowdeselect\"\n    >        \n    </tbody>\n</table>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}"]
                    }] }
        ];
        /** @nocollapse */
        AngularTreeGridComponent.ctorParameters = function () {
            return [
                { type: AngularTreeGridService }
            ];
        };
        AngularTreeGridComponent.propDecorators = {
            data: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            cellclick: [{ type: i0.Output }],
            expand: [{ type: i0.Output }],
            collapse: [{ type: i0.Output }],
            rowselect: [{ type: i0.Output }],
            rowdeselect: [{ type: i0.Output }],
            rowselectall: [{ type: i0.Output }],
            rowdeselectall: [{ type: i0.Output }],
            rowadd: [{ type: i0.Output }],
            rowsave: [{ type: i0.Output }],
            rowdelete: [{ type: i0.Output }]
        };
        return AngularTreeGridComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-body/tree-body.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeBodyComponent = /** @class */ (function () {
        function TreeBodyComponent(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
            this.parents = [];
        }
        /**
         * @return {?}
         */
        TreeBodyComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.display_data = this.store.getDisplayData();
                this.angularTreeGridService.display_data_observable$.subscribe(( /**
                 * @param {?} store
                 * @return {?}
                 */function (store) {
                    _this.display_data = _this.store.getDisplayData();
                    _this.setParents();
                }));
                this.setParents();
            };
        /**
         * @return {?}
         */
        TreeBodyComponent.prototype.setParents = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.parents = this.store.raw_data.map(( /**
                 * @param {?} element
                 * @return {?}
                 */function (element) {
                    return {
                        'id': element[_this.configs.id_field],
                        'value': element[_this.configs.parent_display_field]
                    };
                }));
            };
        /**
         * @param {?} element
         * @return {?}
         */
        TreeBodyComponent.prototype.refreshData = /**
         * @param {?} element
         * @return {?}
         */
            function (element) {
                // If edit parent is not true then don't refresh.
                if (!this.configs.actions.edit_parent) {
                    return;
                }
                element[this.configs.parent_id_field] = parseInt(element[this.configs.parent_id_field], 10);
                this.expand_tracker = {};
                this.edit_tracker = {};
                this.store.processData(this.store.getRawData(), this.expand_tracker, this.configs, this.edit_tracker, this.internal_configs);
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.onRowExpand = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                /** @type {?} */
                var row_data = event.data;
                if (!this.configs.load_children_on_expand) {
                    this.expand_tracker[row_data.pathx] = true;
                    this.expand.emit(event);
                }
                else {
                    this.angularTreeGridService.emitExpandRowEvent(this.expand_tracker, this.expand, this.store, row_data, this.configs);
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.onRowCollapse = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                var _this = this;
                /** @type {?} */
                var row_data = event.data;
                this.expand_tracker[row_data.pathx] = false;
                // Collapse all of its children.
                /** @type {?} */
                var keys = Object.keys(this.expand_tracker);
                keys.forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) {
                    if (key.indexOf(row_data.pathx) !== -1) {
                        _this.expand_tracker[key] = 0;
                    }
                }));
                this.collapse.emit(event);
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeBodyComponent.prototype.saveRecord = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                var _this = this;
                /** @type {?} */
                var element = $event.data;
                if (this.configs.actions.resolve_edit) {
                    /** @type {?} */
                    var promise = new Promise(( /**
                     * @param {?} resolve
                     * @param {?} reject
                     * @return {?}
                     */function (resolve, reject) {
                        _this.rowsave.emit({
                            data: element,
                            resolve: resolve
                        });
                    }));
                    promise.then(( /**
                     * @return {?}
                     */function () {
                        _this.checkAndRefreshData(element);
                    })).catch(( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) { }));
                }
                else {
                    this.checkAndRefreshData(element);
                    this.rowsave.emit(element);
                }
            };
        /**
         * @param {?} element
         * @return {?}
         */
        TreeBodyComponent.prototype.checkAndRefreshData = /**
         * @param {?} element
         * @return {?}
         */
            function (element) {
                this.edit_tracker[element[this.configs.id_field]] = false;
                this.internal_configs.show_parent_col = false;
                // Only refresh if Parent has been changed.
                if (this.internal_configs.current_edited_row[this.configs.parent_id_field]
                    !== element[this.configs.parent_id_field]) {
                    this.refreshData(element);
                }
            };
        /**
         * @param {?} element
         * @return {?}
         */
        TreeBodyComponent.prototype.addRow = /**
         * @param {?} element
         * @return {?}
         */
            function (element) {
                var _this = this;
                if (this.configs.actions.resolve_add) {
                    /** @type {?} */
                    var promise = new Promise(( /**
                     * @param {?} resolve
                     * @param {?} reject
                     * @return {?}
                     */function (resolve, reject) {
                        _this.rowadd.emit({
                            data: element,
                            resolve: resolve
                        });
                    }));
                    promise.then(( /**
                     * @return {?}
                     */function () {
                        _this.internal_configs.show_add_row = false;
                        _this.refreshData(element);
                    })).catch(( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) { }));
                }
                else {
                    this.refreshData(element);
                    this.internal_configs.show_add_row = false;
                    this.rowadd.emit(element);
                }
            };
        /**
         * @param {?} row_data
         * @return {?}
         */
        TreeBodyComponent.prototype.cancelEdit = /**
         * @param {?} row_data
         * @return {?}
         */
            function (row_data) {
                /** @type {?} */
                var index = row_data[this.configs.id_field];
                // Cancel all changes ie copy from back up.
                Object.assign(row_data, this.internal_configs.current_edited_row);
                this.edit_tracker[index] = false;
                this.internal_configs.show_parent_col = false;
            };
        /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.selectRow = /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
            function (row_data, event) {
                // Don't run if Multi select is enabled.
                if (this.configs.multi_select) {
                    return;
                }
                this.store.getDisplayData().forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    data.row_selected = false;
                }));
                row_data.row_selected = true;
                this.rowselect.emit({ data: row_data, event: event });
            };
        /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.selectRowOnCheck = /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
            function (row_data, event) {
                if (event.target.checked) {
                    row_data.row_selected = true;
                    this.rowselect.emit({ data: row_data, event: event });
                }
                else {
                    row_data.row_selected = false;
                    this.rowdeselect.emit({ data: row_data, event: event });
                }
                this.setSelectAllConfig();
            };
        /**
         * Set Select All config on Select change.
         *
         */
        /**
         * Set Select All config on Select change.
         *
         * @return {?}
         */
        TreeBodyComponent.prototype.setSelectAllConfig = /**
         * Set Select All config on Select change.
         *
         * @return {?}
         */
            function () {
                /** @type {?} */
                var select_all = true;
                this.store.getDisplayData().forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    if (!data.row_selected) {
                        select_all = false;
                    }
                }));
                this.internal_configs.all_selected = select_all;
            };
        TreeBodyComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-tree-body]',
                        template: "<ng-container *ngIf=\"configs\">\n  <tr *ngIf=\"store.raw_data.length==0\">\n    <td [innerHTML]=\"configs.data_loading_text\" [attr.colspan]=\"columns.length + 1\" style=\"text-align: center\"></td>\n  </tr>\n  <tr db-filter-row [columns]=\"columns\" [configs]=\"configs\" [store]=\"store\" [internal_configs]=\"internal_configs\"\n    *ngIf=\"configs.filter\" [expand_tracker]=\"expand_tracker\" [ngClass]=\"configs.css.row_filter_class\">\n  </tr>\n  <tr db-add-row [columns]=\"columns\" [configs]=\"configs\" [internal_configs]=\"internal_configs\" [store]=\"store\"\n    (rowadd)=\"addRow($event)\" *ngIf=\"internal_configs.show_add_row\" class=\"{{configs.row_class_function()}}\">\n  </tr>\n  <ng-container *ngIf=\"configs.subgrid\">\n    <tr db-subgrid *ngFor=\"let row_data of display_data\" class=\"subgrid-row\" [configs]=\"configs\"\n      [internal_configs]=\"internal_configs\" [expand_tracker]=\"expand_tracker\" [edit_tracker]=\"edit_tracker\"\n      [store]=\"store\" [row_data]=\"row_data\" [cellclick]=\"cellclick\" [rowselect]=\"rowselect\" [rowdeselect]=\"rowdeselect\"\n      [expand]=\"expand\" [rowsave]=\"rowsave\" [rowdelete]=\"rowdelete\">\n\n    </tr>\n  </ng-container>\n  <ng-container *ngIf=\"!configs.subgrid\">\n    <tr *ngFor=\"let row_data of display_data\"\n      [attr.class]=\"configs.row_class_function(row_data) + ' ' + (row_data.row_selected ? configs.css.row_selection_class : '')\"\n      (click)=\"selectRow(row_data, $event)\">\n      <ng-container *ngIf=\"expand_tracker[row_data.parent_pathx]\">\n        <td *ngIf=\"configs.multi_select\" class=\"checkbox_column\">\n          <input type=\"checkbox\" [checked]=\"row_data.row_selected\" (click)=\"selectRowOnCheck(row_data, $event)\"\n            [attr.disabled]=\"row_data.selection_disabled\">\n        </td>\n        <td db-tree-cell-actions\n          *ngIf=\"((configs.actions.edit || configs.actions.delete || configs.actions.add) && (configs.action_column_position =='first'))\"\n          [row_data]=\"row_data\" [configs]=\"configs\" [store]=\"store\" [edit_tracker]=\"edit_tracker\"\n          [internal_configs]=\"internal_configs\" [rowdelete]=\"rowdelete\" (canceledit)=\"cancelEdit($event)\"\n          (editcomplete)=\"saveRecord($event)\">\n        </td>\n        <td *ngFor=\"let column of columns; index as i\" class=\"{{column.css_class}}\"\n          [ngClass]=\"{'column-hide': column.hidden, 'expand-column': i == 0}\">\n          <db-tree-cell [configs]=\"configs\" [column]=\"column\" [index]=\"i\" [row_data]=\"row_data\"\n            [expand_tracker]=\"expand_tracker\" [edit_on]=\"edit_tracker[row_data[configs.id_field]]\"\n            [cellclick]=\"cellclick\" (rowexpand)=\"onRowExpand($event)\" (rowcollapse)=\"onRowCollapse($event)\"\n            (editcomplete)=\"saveRecord($event)\">\n          </db-tree-cell>\n        </td>\n        <td *ngIf=\"configs.show_parent_on_edit && internal_configs.show_parent_col\">\n          <select *ngIf=\"edit_tracker[row_data[configs.id_field]]\" [(ngModel)]=\"row_data[configs.parent_id_field]\">\n            <option *ngFor=\"let parent of parents\" [value]=\"parent.id\">{{parent.value}}</option>\n          </select>\n        </td>\n\n        <!-- Add column to fix UI issue when add row is enabled but don't show when edit is enabled for the row -->\n        <td *ngIf=\"internal_configs.show_add_row && !(internal_configs.show_parent_col && configs.show_parent_on_edit)\">\n        </td>\n\n        <td db-tree-cell-actions\n          *ngIf=\"((configs.actions.edit || configs.actions.delete || configs.actions.add) && (configs.action_column_position =='last'))\"\n          [row_data]=\"row_data\" [configs]=\"configs\" [store]=\"store\" [edit_tracker]=\"edit_tracker\"\n          [internal_configs]=\"internal_configs\" [rowdelete]=\"rowdelete\" (canceledit)=\"cancelEdit($event)\"\n          (editcomplete)=\"saveRecord($event)\">\n        </td>\n      </ng-container>\n    </tr>\n    <tr *ngIf=\"configs.show_summary_row\">\n      <td *ngIf=\"configs.multi_select\"></td>\n      <td *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add)\"></td>\n      <td *ngFor=\"let column of configs.columns\">\n        <div [innerHTML]=\"column.summary_renderer && column.summary_renderer(display_data)\"></div>\n      </td>\n    </tr>\n  </ng-container>\n\n</ng-container>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr.subgrid-row{background:#fcfcfc}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}tr td.checkbox_column{text-align:center}tr td.expand-column{padding:.3rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}"]
                    }] }
        ];
        /** @nocollapse */
        TreeBodyComponent.ctorParameters = function () {
            return [
                { type: AngularTreeGridService }
            ];
        };
        TreeBodyComponent.propDecorators = {
            store: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            edit_tracker: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            columns: [{ type: i0.Input }],
            cellclick: [{ type: i0.Input }],
            expand: [{ type: i0.Input }],
            collapse: [{ type: i0.Input }],
            rowdelete: [{ type: i0.Input }],
            rowsave: [{ type: i0.Input }],
            rowadd: [{ type: i0.Input }],
            rowselect: [{ type: i0.Input }],
            rowdeselect: [{ type: i0.Input }]
        };
        return TreeBodyComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-cell/tree-cell.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellComponent = /** @class */ (function () {
        function TreeCellComponent() {
            this.rowexpand = new i0.EventEmitter();
            this.rowcollapse = new i0.EventEmitter();
            this.canceledit = new i0.EventEmitter();
            this.editcomplete = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeCellComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.is_expand_column = this.index === 0;
                this.show_expand_icon = !this.row_data.leaf;
                // If user mentions a node as leaf.
                if (this.configs.load_children_on_expand) {
                    this.show_expand_icon = !this.row_data.leaf_node;
                }
                this.cell_value = this.row_data[this.column.name];
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeCellComponent.prototype.expandRow = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.index === 0 && (!this.row_data.leaf || this.configs.load_children_on_expand)) {
                    this.rowexpand.emit({ event: event, data: this.row_data });
                    event.stopPropagation();
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeCellComponent.prototype.collapseRow = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.index === 0 && (!this.row_data.leaf || this.configs.load_children_on_expand)) {
                    this.rowcollapse.emit({ event: event, data: this.row_data });
                    event.stopPropagation();
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeCellComponent.prototype.onCellClick = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                this.cellclick.emit({ column: this.column, row: this.row_data, event: event });
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeCellComponent.prototype.onEditComplete = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                this.editcomplete.emit({ event: $event, data: this.row_data });
            };
        TreeCellComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-tree-cell',
                        template: "<div (click)=\"onCellClick($event)\">\n  <ng-container *ngIf=\"is_expand_column\">\n    <div [ngStyle]=\"{'padding-left': row_data.leaf ? row_data.levelx * 20 + 'px' : row_data.levelx * 10 + 'px'}\">\n      <span class=\"no-expand-icon\" *ngIf=\" row_data.levelx == 0 && row_data.leaf\"></span>\n      <ng-container *ngIf=\"!expand_tracker[row_data.pathx]\">\n        <span (click)=\"expandRow($event)\">\n          <i [ngClass]=\"configs.css.expand_class\" class=\"expand-icon\" aria-hidden=\"true\"\n            [ngStyle]=\"{'visibility': row_data.expand_disabled ? 'hidden' : 'visible'}\" *ngIf=\"show_expand_icon\"></i>\n        </span>\n      </ng-container>\n      <ng-container *ngIf=\"expand_tracker[row_data.pathx]\">\n        <span *ngIf=\"row_data.is_loading\" class=\"childred-loader\"></span>\n        <span (click)=\"collapseRow($event)\" *ngIf=\"!row_data.is_loading\">\n          <i [ngClass]=\"configs.css.collapse_class\" class=\"expand-icon\" aria-hidden=\"true\"\n            [ngStyle]=\"{'visibility': row_data.expand_disabled ? 'hidden' : 'visible'}\" *ngIf=\"show_expand_icon\"></i>\n        </span>\n      </ng-container>\n      <ng-container *ngIf=\"!edit_on || !column.editable\" [ngSwitch]=\"column.type\">\n        <db-custom-cell-component *ngSwitchCase=\"'custom'\" [column]=\"column\" [row_data]=\"row_data\">\n        </db-custom-cell-component>\n        <db-tree-cell-view *ngSwitchDefault [column]=\"column\" [row_data]=\"row_data\">\n        </db-tree-cell-view>\n      </ng-container>\n      <ng-container *ngIf=\"edit_on && column.editable\">\n        <db-custom-cell-editor-component *ngIf=\"column.editor\" [cell_value]=\"cell_value\" [column]=\"column\"\n          [row_data]=\"row_data\" (canceledit)=\"canceledit.emit(row_data['pathx'])\"\n          (editcomplete)=\"onEditComplete($event)\">\n        </db-custom-cell-editor-component>\n        <db-tree-cell-editor *ngIf=\"!column.editor\" [cell_value]=\"cell_value\" [row_data]=\"row_data\" [column]=\"column\"\n          [expandable_column]=true (canceledit)=\"canceledit.emit(row_data['pathx'])\"\n          (editcomplete)=\"onEditComplete($event)\">\n        </db-tree-cell-editor>\n      </ng-container>\n    </div>\n  </ng-container>\n  <ng-container *ngIf=\"!is_expand_column\">\n    <ng-container *ngIf=\"!edit_on || !column.editable\" [ngSwitch]=\"column.type\">\n      <db-custom-cell-component *ngSwitchCase=\"'custom'\" [column]=\"column\" [row_data]=\"row_data\">\n      </db-custom-cell-component>\n      <db-tree-cell-view *ngSwitchDefault [column]=\"column\" [row_data]=\"row_data\">\n      </db-tree-cell-view>\n    </ng-container>\n\n    <ng-container *ngIf=\"edit_on && column.editable\">\n      <db-custom-cell-editor-component *ngIf=\"column.editor\" [cell_value]=\"cell_value\" [column]=\"column\"\n        [row_data]=\"row_data\" (canceledit)=\"canceledit.emit(row_data['pathx'])\" (editcomplete)=\"onEditComplete($event)\">\n      </db-custom-cell-editor-component>\n      <db-tree-cell-editor *ngIf=\"!column.editor\" [cell_value]=\"cell_value\" [row_data]=\"row_data\" [column]=\"column\"\n        [expandable_column]=false (canceledit)=\"canceledit.emit(row_data['pathx'])\"\n        (editcomplete)=\"onEditComplete($event)\">\n      </db-tree-cell-editor>\n    </ng-container>\n  </ng-container>\n</div>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}i.expand-icon{margin-right:8px}span.no-expand-icon{display:inline-block;width:14px}i.plus{border:1px solid transparent;margin-right:32px}i.plus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}i.plus:after{content:'';width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}i.minus{border:1px solid transparent;margin-right:32px}i.minus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}span.childred-loader{border:3px solid #f3f3f3;-webkit-animation:1s linear infinite spin;animation:1s linear infinite spin;border-top:3px solid #555;border-radius:50%;width:10px;height:10px;display:inline-block;margin-right:5px}@-webkit-keyframes spin{0%{transform:rotate(0)}100%{transform:rotate(360deg)}}@keyframes spin{0%{transform:rotate(0)}100%{transform:rotate(360deg)}}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellComponent.ctorParameters = function () { return []; };
        TreeCellComponent.propDecorators = {
            configs: [{ type: i0.Input }],
            index: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            column: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            cellclick: [{ type: i0.Input }],
            edit_on: [{ type: i0.Input }],
            rowexpand: [{ type: i0.Output }],
            rowcollapse: [{ type: i0.Output }],
            canceledit: [{ type: i0.Output }],
            editcomplete: [{ type: i0.Output }]
        };
        return TreeCellComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-cell/components/tree-cell-view/default/tree-cell-view.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellViewComponent = /** @class */ (function () {
        function TreeCellViewComponent() {
        }
        /**
         * @return {?}
         */
        TreeCellViewComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        TreeCellViewComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-tree-cell-view',
                        template: "<span [innerHTML]=\"column.renderer ? column.renderer(row_data[column.name], row_data) : row_data[column.name]\"></span>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        TreeCellViewComponent.ctorParameters = function () { return []; };
        TreeCellViewComponent.propDecorators = {
            column: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }]
        };
        return TreeCellViewComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-cell/components/tree-cell-view/custom/custom-tree-cell.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomCellViewComponent = /** @class */ (function () {
        function CustomCellViewComponent(resolver) {
            this.resolver = resolver;
        }
        /**
         * @return {?}
         */
        CustomCellViewComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.column.component && !this.custom_component) {
                    this.createCustomComponent();
                    this.callOnComponentInit();
                }
            };
        /**
         * @return {?}
         */
        CustomCellViewComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.custom_component) {
                    this.custom_component.destroy();
                }
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellViewComponent.prototype.createCustomComponent = /**
         * @protected
         * @return {?}
         */
            function () {
                /** @type {?} */
                var componentFactory = this.resolver.resolveComponentFactory(this.column.component);
                this.custom_component = this.custom_view.createComponent(componentFactory);
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellViewComponent.prototype.callOnComponentInit = /**
         * @protected
         * @return {?}
         */
            function () {
                this.column.on_component_init && this.column.on_component_init(this.custom_component.instance);
                this.custom_component.instance.cell_value = this.row_data[this.column.name];
                this.custom_component.instance.row_data = this.row_data;
                this.custom_component.instance.column = this.column;
            };
        CustomCellViewComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-custom-cell-component',
                        template: "\n      <ng-template #customView></ng-template>\n    "
                    }] }
        ];
        /** @nocollapse */
        CustomCellViewComponent.ctorParameters = function () {
            return [
                { type: i0.ComponentFactoryResolver }
            ];
        };
        CustomCellViewComponent.propDecorators = {
            column: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            custom_view: [{ type: i0.ViewChild, args: ['customView', { read: i0.ViewContainerRef },] }]
        };
        return CustomCellViewComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-cell/components/tree-cell-actions/tree-cell-actions.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellActionsComponent = /** @class */ (function () {
        function TreeCellActionsComponent() {
            this.editcomplete = new i0.EventEmitter();
            this.canceledit = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeCellActionsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.display_data = this.store.getDisplayData();
            };
        /**
         * @param {?} index
         * @param {?} row_data
         * @return {?}
         */
        TreeCellActionsComponent.prototype.enableEdit = /**
         * @param {?} index
         * @param {?} row_data
         * @return {?}
         */
            function (index, row_data) {
                this.edit_tracker[index] = true;
                // Only if edit_parent is true.
                if (this.configs.actions.edit_parent) {
                    this.internal_configs.show_parent_col = true;
                }
                this.internal_configs.current_edited_row = __assign({}, row_data);
            };
        /**
         * @param {?} pathx
         * @return {?}
         */
        TreeCellActionsComponent.prototype.findRecordIndex = /**
         * @param {?} pathx
         * @return {?}
         */
            function (pathx) {
                for (var index in this.store.processed_data) {
                    if (this.store.processed_data[index].pathx === pathx) {
                        return Number(index);
                    }
                }
            };
        /**
         * @param {?} rec
         * @return {?}
         */
        TreeCellActionsComponent.prototype.deleteRecord = /**
         * @param {?} rec
         * @return {?}
         */
            function (rec) {
                var _this = this;
                /** @type {?} */
                var index = this.findRecordIndex(rec.pathx);
                if (this.configs.actions.resolve_delete) {
                    /** @type {?} */
                    var promise = new Promise(( /**
                     * @param {?} resolve
                     * @param {?} reject
                     * @return {?}
                     */function (resolve, reject) {
                        _this.rowdelete.emit({
                            data: rec,
                            resolve: resolve
                        });
                    }));
                    promise.then(( /**
                     * @return {?}
                     */function () {
                        _this.store.processed_data.splice(index, 1);
                        _this.deleteChildren(rec);
                        _this.store.refreshDisplayData();
                    })).catch(( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) { }));
                }
                else {
                    this.store.processed_data.splice(index, 1);
                    this.deleteChildren(rec);
                    this.store.refreshDisplayData();
                    this.rowdelete.emit(rec);
                }
            };
        /**
         * @param {?} parent
         * @return {?}
         */
        TreeCellActionsComponent.prototype.deleteChildren = /**
         * @param {?} parent
         * @return {?}
         */
            function (parent) {
                /** @type {?} */
                var display_data = __spread(this.store.processed_data);
                /** @type {?} */
                var pathx = parent.pathx;
                for (var index = 0; index < display_data.length; index++) {
                    /** @type {?} */
                    var record = display_data[index];
                    if (record.pathx.includes(pathx)) {
                        /** @type {?} */
                        var index_1 = this.findRecordIndex(record.pathx);
                        this.store.processed_data.splice(index_1, 1);
                    }
                }
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeCellActionsComponent.prototype.saveRecord = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                this.editcomplete.emit({ event: $event, data: this.row_data });
            };
        TreeCellActionsComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-tree-cell-actions]',
                        template: "<ng-container *ngIf=\"configs.actions.edit && configs.row_edit_function(row_data)\">\n  <div *ngIf=\"!edit_tracker[row_data[configs.id_field]]\" class=\"icon-container\">\n    <i (click)=\"enableEdit(row_data[configs.id_field], row_data)\" *ngIf=\"configs.css.edit_class\" title=\"Edit row\" class=\"{{this.configs.css.edit_class}}\" aria-hidden=\"true\" ></i>\n    <svg (click)=\"enableEdit(row_data[configs.id_field], row_data)\" *ngIf=\"!configs.css.edit_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Edit row</title><g data-name=\"Layer 2\"><g data-name=\"edit\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M19.4 7.34L16.66 4.6A2 2 0 0 0 14 4.53l-9 9a2 2 0 0 0-.57 1.21L4 18.91a1 1 0 0 0 .29.8A1 1 0 0 0 5 20h.09l4.17-.38a2 2 0 0 0 1.21-.57l9-9a1.92 1.92 0 0 0-.07-2.71zM9.08 17.62l-3 .28.27-3L12 9.32l2.7 2.7zM16 10.68L13.32 8l1.95-2L18 8.73z\"/></g></g></svg>             \n  </div>\n  <ng-container *ngIf=\"edit_tracker[row_data[configs.id_field]]\">\n    <div class=\"icon-container\">\n      <i (click)=\"saveRecord($event)\" *ngIf=\"configs.css.save_class\" title=\"Save row\" class=\"{{this.configs.css.save_class}}\" aria-hidden=\"true\"></i>\n      <svg (click)=\"saveRecord($event)\" title=\"Save row\" *ngIf=\"!configs.css.save_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Save row</title><g data-name=\"Layer 2\"><g data-name=\"save\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M20.12 8.71l-4.83-4.83A3 3 0 0 0 13.17 3H6a3 3 0 0 0-3 3v12a3 3 0 0 0 3 3h12a3 3 0 0 0 3-3v-7.17a3 3 0 0 0-.88-2.12zM10 19v-2h4v2zm9-1a1 1 0 0 1-1 1h-2v-3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3H6a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h2v5a1 1 0 0 0 1 1h4a1 1 0 0 0 0-2h-3V5h3.17a1.05 1.05 0 0 1 .71.29l4.83 4.83a1 1 0 0 1 .29.71z\"/></g></g></svg>\n    </div>\n    <div class=\"icon-container\">\n      <i (click)=\"canceledit.emit(row_data)\" *ngIf=\"configs.css.cancel_class\" title=\"Cancel row\" class=\"{{this.configs.css.cancel_class}}\" aria-hidden=\"true\"></i>\n      <svg (click)=\"canceledit.emit(row_data)\" *ngIf=\"!configs.css.cancel_class\" title=\"Cancel row\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Cancel row</title><g data-name=\"Layer 2\"><g data-name=\"close\"><rect width=\"24\" height=\"24\" transform=\"rotate(180 12 12)\" opacity=\"0\"/><path d=\"M13.41 12l4.3-4.29a1 1 0 1 0-1.42-1.42L12 10.59l-4.29-4.3a1 1 0 0 0-1.42 1.42l4.3 4.29-4.3 4.29a1 1 0 0 0 0 1.42 1 1 0 0 0 1.42 0l4.29-4.3 4.29 4.3a1 1 0 0 0 1.42 0 1 1 0 0 0 0-1.42z\"/></g></g></svg>\n    </div>\n  </ng-container>\n</ng-container>            \n<div \n  class=\"icon-container\"\n  *ngIf=\"\n      configs.actions.delete && \n      !edit_tracker[row_data[configs.id_field]] && \n      configs.row_delete_function(row_data)\">\n  <i *ngIf=\"configs.css.delete_class\" title=\"Delete row\" (click)=\"deleteRecord(row_data)\" class=\"{{this.configs.css.delete_class}}\" aria-hidden=\"true\"></i>\n  <svg *ngIf=\"!configs.css.delete_class\" title=\"Delete row\" (click)=\"deleteRecord(row_data)\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Delete row</title><g data-name=\"Layer 2\"><g data-name=\"trash-2\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M21 6h-5V4.33A2.42 2.42 0 0 0 13.5 2h-3A2.42 2.42 0 0 0 8 4.33V6H3a1 1 0 0 0 0 2h1v11a3 3 0 0 0 3 3h10a3 3 0 0 0 3-3V8h1a1 1 0 0 0 0-2zM10 4.33c0-.16.21-.33.5-.33h3c.29 0 .5.17.5.33V6h-4zM18 19a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1V8h12z\"/><path d=\"M9 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z\"/><path d=\"M15 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z\"/></g></g></svg>            \n</div>",
                        styles: ["svg{width:25px;padding-right:5px}div.icon-container{display:inline-block;width:50%;text-align:center;color:#000;cursor:pointer}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellActionsComponent.ctorParameters = function () { return []; };
        TreeCellActionsComponent.propDecorators = {
            store: [{ type: i0.Input }],
            edit_tracker: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            rowdelete: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            editcomplete: [{ type: i0.Output }],
            canceledit: [{ type: i0.Output }]
        };
        return TreeCellActionsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-cell/components/tree-cell-editor/default/default-editor.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DefaultEditor = /** @class */ (function () {
        function DefaultEditor() {
            this.canceledit = new i0.EventEmitter();
            this.editcomplete = new i0.EventEmitter();
            this.cellclick = new i0.EventEmitter();
        }
        DefaultEditor.propDecorators = {
            canceledit: [{ type: i0.Output }],
            editcomplete: [{ type: i0.Output }],
            cellclick: [{ type: i0.Output }]
        };
        return DefaultEditor;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-cell/components/tree-cell-editor/custom/custom-tree-cell-Editor.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomCellEditorComponent = /** @class */ (function (_super) {
        __extends(CustomCellEditorComponent, _super);
        function CustomCellEditorComponent(resolver) {
            var _this = _super.call(this) || this;
            _this.resolver = resolver;
            return _this;
        }
        /**
         * @return {?}
         */
        CustomCellEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.column.editor && !this.custom_component) {
                    this.createCustomComponent();
                    this.callOnComponentInit();
                }
            };
        /**
         * @return {?}
         */
        CustomCellEditorComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.custom_component) {
                    this.custom_component.destroy();
                }
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellEditorComponent.prototype.createCustomComponent = /**
         * @protected
         * @return {?}
         */
            function () {
                /** @type {?} */
                var componentFactory = this.resolver.resolveComponentFactory(this.column.editor);
                this.custom_component = this.custom_view.createComponent(componentFactory);
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellEditorComponent.prototype.callOnComponentInit = /**
         * @protected
         * @return {?}
         */
            function () {
                var _this = this;
                this.column.on_component_init && this.column.on_component_init(this.custom_component.instance);
                this.custom_component.instance.cell_value = this.cell_value;
                this.custom_component.instance.row_data = this.row_data;
                this.custom_component.instance.column = this.column;
                this.custom_component.instance.editcomplete.subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) { return _this.editcomplete.emit(event); }));
                this.custom_component.instance.canceledit.subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) { return _this.canceledit.emit(event); }));
                this.custom_component.instance.cellclick.subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) { return _this.cellclick.emit(event); }));
            };
        CustomCellEditorComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-custom-cell-editor-component',
                        template: "\n      <ng-template #customView></ng-template>\n    "
                    }] }
        ];
        /** @nocollapse */
        CustomCellEditorComponent.ctorParameters = function () {
            return [
                { type: i0.ComponentFactoryResolver }
            ];
        };
        CustomCellEditorComponent.propDecorators = {
            column: [{ type: i0.Input }],
            cell_value: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            custom_view: [{ type: i0.ViewChild, args: ['customView', { read: i0.ViewContainerRef },] }]
        };
        return CustomCellEditorComponent;
    }(DefaultEditor));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-cell/components/tree-cell-editor/default/cell-editor/tree-cell-editor.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellEditorComponent = /** @class */ (function (_super) {
        __extends(TreeCellEditorComponent, _super);
        function TreeCellEditorComponent() {
            return _super.call(this) || this;
        }
        /**
         * @return {?}
         */
        TreeCellEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        TreeCellEditorComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-tree-cell-editor',
                        template: "<input type=\"text\" \n    [(ngModel)]=\"row_data[column.name]\" \n    [ngClass]=\"{'cell-default': true, 'expandable-editor': expandable_column}\"\n    (click)=\"cellclick.emit($event)\"\n    (keydown.enter)=\"editcomplete.emit($event)\"\n    (keydown.esc)=\"canceledit.emit()\"\n    size=\"1\"\n    >",
                        styles: ["input.cell-default{padding:5px;box-sizing:border-box;width:100%}input.expandable-editor{width:calc(100% - 18px)}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellEditorComponent.ctorParameters = function () { return []; };
        TreeCellEditorComponent.propDecorators = {
            cell_value: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            column: [{ type: i0.Input }],
            expandable_column: [{ type: i0.Input }]
        };
        return TreeCellEditorComponent;
    }(DefaultEditor));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-cell/tree-cell.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellModule = /** @class */ (function () {
        function TreeCellModule() {
        }
        TreeCellModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [
                            TreeCellComponent,
                            TreeCellViewComponent,
                            CustomCellViewComponent,
                            TreeCellActionsComponent,
                            CustomCellEditorComponent,
                            TreeCellEditorComponent
                        ],
                        imports: [
                            common.CommonModule,
                            forms.FormsModule
                        ],
                        exports: [
                            TreeCellComponent,
                            CustomCellViewComponent,
                            CustomCellEditorComponent,
                            TreeCellEditorComponent,
                            TreeCellActionsComponent
                        ],
                        providers: [AngularTreeGridService]
                    },] }
        ];
        return TreeCellModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-body/components/add-row/add-row.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AddRowComponent = /** @class */ (function () {
        function AddRowComponent() {
            this.row_data = {};
            this.parents = [];
            this.rowadd = new i0.EventEmitter();
            this.canceledit = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        AddRowComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.raw_data = this.store.getRawData();
                this.columns.forEach(( /**
                 * @param {?} column
                 * @return {?}
                 */function (column) {
                    _this.row_data[column.name] = '';
                }));
                this.parents = this.raw_data.map(( /**
                 * @param {?} element
                 * @return {?}
                 */function (element) {
                    return {
                        'id': element[_this.configs.id_field],
                        'value': element[_this.configs.parent_display_field]
                    };
                }));
            };
        /**
         * @param {?} e
         * @return {?}
         */
        AddRowComponent.prototype.saveAddRecord = /**
         * @param {?} e
         * @return {?}
         */
            function (e) {
                this.raw_data.push(this.row_data);
                this.rowadd.emit(this.row_data);
            };
        /**
         * @return {?}
         */
        AddRowComponent.prototype.cancelAddEdit = /**
         * @return {?}
         */
            function () {
                this.internal_configs.show_add_row = false;
            };
        AddRowComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-add-row]',
                        template: "<td *ngIf=\"configs.multi_select\"></td>\n<td>\n  <div class=\"icon-container\">\n    <i (click)=\"saveAddRecord($event)\" *ngIf=\"configs.css.save_class\" title=\"Save row\" class=\"{{this.configs.css.save_class}}\" aria-hidden=\"true\"></i>\n    <svg (click)=\"saveAddRecord($event)\" title=\"Save row\" *ngIf=\"!configs.css.save_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Save row</title><g data-name=\"Layer 2\"><g data-name=\"save\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M20.12 8.71l-4.83-4.83A3 3 0 0 0 13.17 3H6a3 3 0 0 0-3 3v12a3 3 0 0 0 3 3h12a3 3 0 0 0 3-3v-7.17a3 3 0 0 0-.88-2.12zM10 19v-2h4v2zm9-1a1 1 0 0 1-1 1h-2v-3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3H6a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h2v5a1 1 0 0 0 1 1h4a1 1 0 0 0 0-2h-3V5h3.17a1.05 1.05 0 0 1 .71.29l4.83 4.83a1 1 0 0 1 .29.71z\"/></g></g></svg>\n  </div>\n  <div class=\"icon-container\">\n    <i (click)=\"cancelAddEdit()\" *ngIf=\"configs.css.cancel_class\" title=\"Cancel row\" class=\"{{this.configs.css.cancel_class}}\" aria-hidden=\"true\"></i>\n    <svg (click)=\"cancelAddEdit()\" *ngIf=\"!configs.css.cancel_class\" title=\"Cancel row\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Cancel row</title><g data-name=\"Layer 2\"><g data-name=\"close\"><rect width=\"24\" height=\"24\" transform=\"rotate(180 12 12)\" opacity=\"0\"/><path d=\"M13.41 12l4.3-4.29a1 1 0 1 0-1.42-1.42L12 10.59l-4.29-4.3a1 1 0 0 0-1.42 1.42l4.3 4.29-4.3 4.29a1 1 0 0 0 0 1.42 1 1 0 0 0 1.42 0l4.29-4.3 4.29 4.3a1 1 0 0 0 1.42 0 1 1 0 0 0 0-1.42z\"/></g></g></svg>\n  </div>\n</td>\n<td *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\" >\n  <div *ngIf=\"column.editable\">\n    <db-custom-cell-editor-component \n        *ngIf=\"column.editor\"\n        [cell_value]=\"\" \n        [column]=\"column\" \n        [row_data]=\"row_data\"\n        (canceledit)=\"cancelAddEdit()\"\n        (editcomplete)=\"saveAddRecord($event)\">\n    </db-custom-cell-editor-component>\n    <db-tree-cell-editor \n        *ngIf=\"!column.editor\"\n        [cell_value]=\"\" \n        [row_data]=\"row_data\" \n        [column]=\"column\"\n        (canceledit)=\"cancelAddEdit()\"\n        (editcomplete)=\"saveAddRecord($event)\"\n        >\n    </db-tree-cell-editor>\n  </div>\n</td>\n<td>\n  <select [(ngModel)]=\"row_data[configs.parent_id_field]\">\n    <option *ngFor=\"let parent of parents\" [value]=\"parent.id\">{{parent.value}}</option>\n  </select>\n</td>",
                        encapsulation: i0.ViewEncapsulation.None,
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr.subgrid-row{background:#fcfcfc}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}tr td.checkbox_column{text-align:center}tr td.expand-column{padding:.3rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}svg{width:25px;padding-right:4px}div.icon-container{display:inline-block;width:50%;text-align:center}"]
                    }] }
        ];
        /** @nocollapse */
        AddRowComponent.ctorParameters = function () { return []; };
        AddRowComponent.propDecorators = {
            store: [{ type: i0.Input }],
            columns: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            rowadd: [{ type: i0.Output }],
            canceledit: [{ type: i0.Output }]
        };
        return AddRowComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-body/components/filter-row/filter-row.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FilterRowComponent = /** @class */ (function () {
        function FilterRowComponent(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
            this.search_values = {};
        }
        /**
         * @return {?}
         */
        FilterRowComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.columns.forEach(( /**
                 * @param {?} column
                 * @return {?}
                 */function (column) {
                    _this.search_values[column.name] = '';
                }));
            };
        /**
         * @return {?}
         */
        FilterRowComponent.prototype.filter = /**
         * @return {?}
         */
            function () {
                this.store.filterBy(this.columns, Object.values(this.search_values));
                // Don't expand for subgrid.
                if (!this.configs.subgrid) {
                    this.angularTreeGridService.expandAll(this.expand_tracker);
                }
            };
        FilterRowComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-filter-row]',
                        template: "<td *ngIf=\"configs.multi_select\"></td>\n<td\n  *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add) && (configs.action_column_position =='first')\">\n</td>\n<td *ngFor=\"let column of columns\">\n  <div *ngIf=\"column.filter\">\n    <input type=\"text\" (keyup)=\"filter()\" [(ngModel)]=\"search_values[column.name]\">\n  </div>\n</td>\n<!-- Add column to fix UI issue when add row is enabled or Edit is enabled -->\n<td *ngIf=\"internal_configs.show_add_row || (internal_configs.show_parent_col && configs.show_parent_on_edit)\"></td>\n<td\n  *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add) && (configs.action_column_position =='last')\">\n</td>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr.subgrid-row{background:#fcfcfc}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}tr td.checkbox_column{text-align:center}tr td.expand-column{padding:.3rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.2rem}td input{width:100%;padding:.1rem;box-sizing:border-box;-webkit-box-sizing:border-box;-moz-box-sizing:border-box}"]
                    }] }
        ];
        /** @nocollapse */
        FilterRowComponent.ctorParameters = function () {
            return [
                { type: AngularTreeGridService }
            ];
        };
        FilterRowComponent.propDecorators = {
            store: [{ type: i0.Input }],
            columns: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }]
        };
        return FilterRowComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/subgrid/subgrid.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SubgridComponent = /** @class */ (function () {
        function SubgridComponent() {
        }
        /**
         * @return {?}
         */
        SubgridComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () { };
        /**
         * @param {?} $event
         * @return {?}
         */
        SubgridComponent.prototype.saveRecord = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                var _this = this;
                /** @type {?} */
                var element = $event.data;
                if (this.configs.actions.resolve_edit) {
                    /** @type {?} */
                    var promise = new Promise(( /**
                     * @param {?} resolve
                     * @param {?} reject
                     * @return {?}
                     */function (resolve, reject) {
                        _this.rowsave.emit({
                            data: element,
                            resolve: resolve
                        });
                    }));
                    promise.then(( /**
                     * @return {?}
                     */function () {
                        _this.checkAndRefreshData(element);
                    })).catch(( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) { }));
                }
                else {
                    this.checkAndRefreshData(element);
                    this.rowsave.emit(element);
                }
            };
        /**
         * @param {?} element
         * @return {?}
         */
        SubgridComponent.prototype.checkAndRefreshData = /**
         * @param {?} element
         * @return {?}
         */
            function (element) {
                this.edit_tracker[element[this.configs.id_field]] = false;
                this.internal_configs.show_parent_col = false;
                // Only refresh if Parent has been changed.
                if (this.internal_configs.current_edited_row[this.configs.parent_id_field]
                    !== element[this.configs.parent_id_field]) {
                    this.refreshData(element);
                }
            };
        /**
         * @param {?} element
         * @return {?}
         */
        SubgridComponent.prototype.refreshData = /**
         * @param {?} element
         * @return {?}
         */
            function (element) {
                // If edit parent is not true then don't refresh.
                if (!this.configs.actions.edit_parent) {
                    return;
                }
                element[this.configs.parent_id_field] = parseInt(element[this.configs.parent_id_field], 10);
                this.expand_tracker = {};
                this.edit_tracker = {};
                this.store.processData(this.store.getRawData(), this.expand_tracker, this.configs, this.edit_tracker, this.internal_configs);
            };
        /**
         * @param {?} row_data
         * @return {?}
         */
        SubgridComponent.prototype.cancelEdit = /**
         * @param {?} row_data
         * @return {?}
         */
            function (row_data) {
                /** @type {?} */
                var index = row_data[this.configs.id_field];
                // Cancel all changes ie copy from back up.
                Object.assign(row_data, this.internal_configs.current_edited_row);
                this.edit_tracker[index] = false;
                this.internal_configs.show_parent_col = false;
            };
        /**
         * @param {?} event
         * @return {?}
         */
        SubgridComponent.prototype.onRowExpand = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                var _this = this;
                /** @type {?} */
                var row_data = event.data;
                /** @type {?} */
                var promise = new Promise(( /**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */function (resolve, reject) {
                    _this.expand.emit({
                        data: row_data,
                        resolve: resolve
                    });
                }));
                this.expand_tracker[row_data.pathx] = true;
                /** @type {?} */
                var blank_row = this.store.showBlankRow(row_data);
                blank_row.loading_children = true;
                // Add Child rows to the table.
                promise.then(( /**
                 * @param {?} child_rows
                 * @return {?}
                 */function (child_rows) {
                    blank_row.loading_children = false;
                    if (child_rows) {
                        child_rows.map(( /**
                         * @param {?} child
                         * @return {?}
                         */function (child) {
                            child.leaf = true;
                        }));
                        blank_row.children = child_rows;
                    }
                    else {
                        // Persist old children. If didn't exist then assign blank array.
                        if (!blank_row.children) {
                            blank_row.children = [];
                        }
                    }
                })).catch(( /**
                 * @param {?} err
                 * @return {?}
                 */function (err) { }));
            };
        /**
         * @param {?} event
         * @return {?}
         */
        SubgridComponent.prototype.onRowCollapse = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                /** @type {?} */
                var row_data = event.data;
                this.expand_tracker[row_data.pathx] = false;
            };
        /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        SubgridComponent.prototype.selectRowOnCheck = /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
            function (row_data, event) {
                if (event.target.checked) {
                    row_data.row_selected = true;
                    this.rowselect.emit({ data: row_data, event: event });
                }
                else {
                    row_data.row_selected = false;
                    this.rowdeselect.emit({ data: row_data, event: event });
                }
                this.setSelectAllConfig();
            };
        /**
         * Set Select All config on Select change.
         *
         */
        /**
         * Set Select All config on Select change.
         *
         * @return {?}
         */
        SubgridComponent.prototype.setSelectAllConfig = /**
         * Set Select All config on Select change.
         *
         * @return {?}
         */
            function () {
                /** @type {?} */
                var select_all = true;
                this.store.getDisplayData().forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    if (!data.row_selected) {
                        select_all = false;
                    }
                }));
                this.internal_configs.all_selected = select_all;
            };
        SubgridComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-subgrid]',
                        template: "<ng-container *ngIf=\"expand_tracker[row_data.parent_pathx]\">\n\n  <!-- Expandable Row -->\n  <ng-container *ngIf=\"!row_data.leaf\">\n    <td *ngIf=\"configs.multi_select\" class=\"checkbox_column\">\n      <input type=\"checkbox\" [checked]=\"row_data.row_selected\" (click)=\"selectRowOnCheck(row_data, $event)\" \n        [attr.disabled]=\"row_data.selection_disabled\">\n    </td>\n    <td db-tree-cell-actions \n      *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add)\"\n      [row_data]=\"row_data\"\n      [configs]=\"configs\"\n      [store]=\"store\"\n      [edit_tracker]=\"edit_tracker\"\n      [internal_configs]=\"internal_configs\"\n      [rowdelete]=\"rowdelete\"\n      (canceledit)=\"cancelEdit($event)\" \n      (editcomplete)=\"saveRecord($event)\"\n      >\n    </td>\n    <td *ngFor=\"let column of configs.columns; index as i\" \n      [ngClass]=\"{'column-hide': column.hidden, 'expand-column': i == 0}\">\n      <db-tree-cell\n        [configs]=\"configs\"\n        [column]=\"column\"\n        [index]=\"i\"\n        [row_data]=\"row_data\"\n        [expand_tracker]=\"expand_tracker\"\n        [edit_on]=\"edit_tracker[row_data[configs.id_field]]\"\n        [cellclick]=\"cellclick\"\n        (rowexpand)=\"onRowExpand($event)\"\n        (rowcollapse)=\"onRowCollapse($event)\"\n        (editcomplete)=\"saveRecord($event)\"\n      >\n      </db-tree-cell>\n    </td>\n  </ng-container>\n\n  <!-- Subgrid Rows -->\n  <ng-container *ngIf=\"row_data.leaf\">    \n    <td *ngIf=\"configs.multi_select\"></td>\n    <td *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add)\"></td>\n    <td [attr.colspan]=\"configs.columns.length\" class=\"subgrid-column\">\n        <table class=\"subgrid-table\">\n          <thead db-subgrid-head\n            [row_data]=\"row_data\"\n            [configs]=\"configs\">\n            \n          </thead>\n          <tbody db-subgrid-body\n            [configs]=\"configs\"\n            [expand_tracker]=\"expand_tracker\"\n            [cellclick]=\"cellclick\"\n            [row_data]=\"row_data\">\n          </tbody>            \n        </table>\n    </td>    \n  </ng-container>  \n</ng-container>",
                        styles: ["tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr.subgrid-row{background:#fcfcfc}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}tr td.checkbox_column{text-align:center}tr td.expand-column{padding:.3rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}.db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr{background:#fff}tr th{font-size:1rem;font-weight:600;line-height:1.25;color:#181818;border:1px solid #cdd5dc;vertical-align:middle;position:relative;box-sizing:border-box}tr th div{padding:.5rem}tr th.column-hide{display:none}tr th.action-column span.icon-container{cursor:pointer}tr th i.plus{border:1px solid transparent}tr th i.plus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}tr th i.plus:after{content:'';width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}th.clear-left-border{border-left:0!important}th.clear-right-border{border-right:0!important}.column-hide{display:none}svg{width:25px;padding-right:3px}td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}td.checkbox_column{text-align:center}td.expand-column{padding:.3rem}td.subgrid-column{padding:0}td.column-hide{display:none}td.clear-left-border{border-left:0!important}td.clear-right-border{border-right:0!important}td table.subgrid-table{border-collapse:collapse;width:100%}"]
                    }] }
        ];
        /** @nocollapse */
        SubgridComponent.ctorParameters = function () { return []; };
        SubgridComponent.propDecorators = {
            store: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            edit_tracker: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            cellclick: [{ type: i0.Input }],
            expand: [{ type: i0.Input }],
            rowselect: [{ type: i0.Input }],
            rowdeselect: [{ type: i0.Input }],
            rowsave: [{ type: i0.Input }],
            rowdelete: [{ type: i0.Input }]
        };
        return SubgridComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/subgrid/components/subgrid-head/subgrid-head.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SubgridHeadComponent = /** @class */ (function () {
        function SubgridHeadComponent() {
        }
        /**
         * @return {?}
         */
        SubgridHeadComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} row_data
         * @param {?} column
         * @return {?}
         */
        SubgridHeadComponent.prototype.sortColumn = /**
         * @param {?} row_data
         * @param {?} column
         * @return {?}
         */
            function (row_data, column) {
                /** @type {?} */
                var sort_by = column.name;
                // If already sorted then reverse.
                column.sort_type = column.sorted ? !column.sort_type : 1;
                column.sorted = 1;
                column.sort_type ? row_data.children.sort(( /**
                 * @param {?} a
                 * @param {?} b
                 * @return {?}
                 */function (a, b) { return (a[sort_by] > b[sort_by]) ? 1 : ((b[sort_by] > a[sort_by]) ? -1 : 0); })) :
                    row_data.children.sort(( /**
                     * @param {?} a
                     * @param {?} b
                     * @return {?}
                     */function (a, b) { return (a[sort_by] < b[sort_by]) ? 1 : ((b[sort_by] < a[sort_by]) ? -1 : 0); }));
            };
        SubgridHeadComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-subgrid-head]',
                        template: "<tr>\n  <th *ngFor=\"let column of configs.subgrid_config.columns\"\n    (click)=\"sortColumn(row_data, column)\" width=\"{{column.width ? column.width : 'auto'}}\"\n    [ngClass]=\"{'sorted': column.sorted,'sortable': column.sortable, 'column-hide': column.hidden}\">\n    {{column.header}}\n    <span *ngIf=\"column.sortable\" [ngClass]=\"column.sorted && column.sort_type == 0?'arrow-down active':'arrow-down'\"></span>\n    <span *ngIf=\"column.sortable\" [ngClass]=\"column.sorted && column.sort_type == 1?'arrow-up active':'arrow-up'\"></span>\n  </th>\n</tr>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr{background:#fff}tr th{font-size:1rem;font-weight:600;line-height:1.25;color:#181818;border:1px solid #cdd5dc;vertical-align:middle;position:relative;box-sizing:border-box}tr th div{padding:.5rem}tr th.column-hide{display:none}tr th.action-column span.icon-container{cursor:pointer}tr th i.plus{border:1px solid transparent}tr th i.plus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}tr th i.plus:after{content:'';width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}th.clear-left-border{border-left:0!important}th.clear-right-border{border-right:0!important}.column-hide{display:none}svg{width:25px;padding-right:3px}th.sortable{cursor:pointer}th.sortable:hover span.arrow-up{border-bottom:6px solid #afafaf}th.sortable:hover span.arrow-down{border-top:6px solid #afafaf}th span.arrow-up{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-bottom:6px solid #ddd;position:relative;top:-18px}th span.arrow-up.active{border-bottom:6px solid #8a8989!important}th span.arrow-down{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:6px solid #ddd;position:relative;left:10px;top:17px}th span.arrow-down.active{border-top:6px solid #8a8989!important}"]
                    }] }
        ];
        /** @nocollapse */
        SubgridHeadComponent.ctorParameters = function () { return []; };
        SubgridHeadComponent.propDecorators = {
            configs: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }]
        };
        return SubgridHeadComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/subgrid/components/subgrid-body/subgrid-body.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SubgridBodyComponent = /** @class */ (function () {
        function SubgridBodyComponent() {
        }
        /**
         * @return {?}
         */
        SubgridBodyComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        SubgridBodyComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-subgrid-body]',
                        template: "<ng-container *ngIf=\"row_data.loading_children\">\n  <tr>\n    <td [attr.colspan]=\"configs.subgrid_config.columns.length\" \n      [innerHTML]=\"configs.subgrid_config.data_loading_text\"\n      class=\"subgrid-loading-text\"></td>\n  </tr>\n</ng-container>\n<ng-container *ngIf=\"!row_data.loading_children\">\n  <tr *ngFor=\"let child_data of row_data.children\">\n    <td *ngFor=\"let column of configs.subgrid_config.columns; index as i\">\n      <db-tree-cell\n        [configs]=\"configs\"\n        [column]=\"column\"\n        [index]=\"1\"\n        [row_data]=\"child_data\"\n        [expand_tracker]=\"expand_tracker\"\n        [cellclick]=\"cellclick\"\n      ></db-tree-cell>\n    </td>\n  </tr>\n  <tr *ngIf=\"configs.subgrid_config.show_summary_row\">\n    <td *ngFor=\"let column of configs.subgrid_config.columns\">\n      <div [innerHTML]=\"column.summary_renderer && column.summary_renderer(row_data.children)\"></div>\n    </td>\n  </tr>\n</ng-container>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr.subgrid-row{background:#fcfcfc}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}tr td.checkbox_column{text-align:center}tr td.expand-column{padding:.3rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}td.subgrid-loading-text{text-align:center}"]
                    }] }
        ];
        /** @nocollapse */
        SubgridBodyComponent.ctorParameters = function () { return []; };
        SubgridBodyComponent.propDecorators = {
            configs: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            cellclick: [{ type: i0.Input }]
        };
        return SubgridBodyComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/subgrid/subgrid.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SubgridModule = /** @class */ (function () {
        function SubgridModule() {
        }
        SubgridModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [SubgridComponent, SubgridHeadComponent, SubgridBodyComponent],
                        imports: [
                            common.CommonModule,
                            TreeCellModule
                        ],
                        exports: [SubgridComponent]
                    },] }
        ];
        return SubgridModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-body/tree-body.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeBodyModule = /** @class */ (function () {
        function TreeBodyModule() {
        }
        TreeBodyModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [TreeBodyComponent, AddRowComponent, FilterRowComponent],
                        imports: [
                            common.CommonModule,
                            TreeCellModule,
                            forms.FormsModule,
                            SubgridModule
                        ],
                        exports: [TreeBodyComponent],
                        providers: [AngularTreeGridService]
                    },] }
        ];
        return TreeBodyModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-head/tree-head.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeHeadComponent = /** @class */ (function () {
        function TreeHeadComponent(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
        }
        /**
         * @return {?}
         */
        TreeHeadComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () { };
        /**
         * @return {?}
         */
        TreeHeadComponent.prototype.addRow = /**
         * @return {?}
         */
            function () {
                this.internal_configs.show_add_row = true;
            };
        /**
         * @param {?} e
         * @return {?}
         */
        TreeHeadComponent.prototype.selectAll = /**
         * @param {?} e
         * @return {?}
         */
            function (e) {
                if (e.target.checked) {
                    this.angularTreeGridService.selectAll(this.store.getDisplayData());
                    this.rowselectall.emit(this.store.getDisplayData());
                }
                else {
                    this.angularTreeGridService.deSelectAll(this.store.getDisplayData());
                    this.rowdeselectall.emit(e);
                }
            };
        TreeHeadComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-tree-head]',
                        template: "<ng-container *ngIf=\"configs\">\n  <tr [ngClass]=\"configs.css.header_class\">\n    <th *ngIf=\"configs.multi_select\" class=\"checkbox_column\">\n      <input type=\"checkbox\" (click)=\"selectAll($event)\" [checked]=\"this.internal_configs.all_selected\">\n    </th>\n    <th\n      *ngIf=\"(configs.actions.add || configs.actions.edit || configs.actions.delete) && (configs.action_column_position =='first')\"\n      class=\"action-column\" width=\"{{configs.action_column_width}}\">\n      <span class=\"icon-container\" (click)=\"addRow()\">\n        <i *ngIf=\"!internal_configs.show_add_row && configs.actions.add\" [ngClass]=\"configs.css.add_class\"\n          aria-hidden=\"true\" title=\"Add a row\"></i>\n      </span>\n      <span *ngIf=\"internal_configs.show_add_row || !configs.actions.add\">{{configs.action_column_text}}</span>\n    </th>\n    <th *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\" [attr.width]=\"column.width\">\n      <div [innerHTML]=\"column.header_renderer ? column.header_renderer(column.header) : column.header\"></div>\n    </th>\n    <th *ngIf=\"(configs.show_parent_on_edit && internal_configs.show_parent_col) || internal_configs.show_add_row\">\n      Parent\n    </th>\n    <th\n      *ngIf=\"(configs.actions.add || configs.actions.edit || configs.actions.delete) && (configs.action_column_position =='last')\"\n      class=\"action-column\" width=\"{{configs.action_column_width}}\">\n      <span class=\"icon-container\" (click)=\"addRow()\">\n        <i *ngIf=\"!internal_configs.show_add_row && configs.actions.add\" [ngClass]=\"configs.css.add_class\"\n          aria-hidden=\"true\" title=\"Add a row\"></i>\n      </span>\n      <span *ngIf=\"internal_configs.show_add_row || !configs.actions.add\">{{configs.action_column_text}}</span>\n    </th>\n  </tr>\n</ng-container>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr{background:#fff}tr th{font-size:1rem;font-weight:600;line-height:1.25;color:#181818;border:1px solid #cdd5dc;vertical-align:middle;position:relative;box-sizing:border-box}tr th div{padding:.5rem}tr th.column-hide{display:none}tr th.action-column span.icon-container{cursor:pointer}tr th i.plus{border:1px solid transparent}tr th i.plus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}tr th i.plus:after{content:'';width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}th.clear-left-border{border-left:0!important}th.clear-right-border{border-right:0!important}.column-hide{display:none}svg{width:25px;padding-right:3px}"]
                    }] }
        ];
        /** @nocollapse */
        TreeHeadComponent.ctorParameters = function () {
            return [
                { type: AngularTreeGridService }
            ];
        };
        TreeHeadComponent.propDecorators = {
            store: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            edit_tracker: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            columns: [{ type: i0.Input }],
            rowselectall: [{ type: i0.Input }],
            rowdeselectall: [{ type: i0.Input }]
        };
        return TreeHeadComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/modules/tree-head/tree-head.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeHeadModule = /** @class */ (function () {
        function TreeHeadModule() {
        }
        TreeHeadModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [TreeHeadComponent],
                        imports: [
                            common.CommonModule
                        ],
                        exports: [TreeHeadComponent],
                        providers: [AngularTreeGridService]
                    },] }
        ];
        return TreeHeadModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/angular-tree-grid.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularTreeGridModule = /** @class */ (function () {
        function AngularTreeGridModule() {
        }
        AngularTreeGridModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [AngularTreeGridComponent],
                        imports: [
                            common.CommonModule,
                            TreeBodyModule,
                            TreeHeadModule
                        ],
                        exports: [AngularTreeGridComponent],
                        providers: [AngularTreeGridService]
                    },] }
        ];
        return AngularTreeGridModule;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: angular-tree-grid.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AngularTreeGridService = AngularTreeGridService;
    exports.AngularTreeGridComponent = AngularTreeGridComponent;
    exports.AngularTreeGridModule = AngularTreeGridModule;
    exports.DefaultEditor = DefaultEditor;
    exports.ɵo = SubgridBodyComponent;
    exports.ɵn = SubgridHeadComponent;
    exports.ɵm = SubgridComponent;
    exports.ɵl = SubgridModule;
    exports.ɵc = AddRowComponent;
    exports.ɵd = FilterRowComponent;
    exports.ɵb = TreeBodyComponent;
    exports.ɵa = TreeBodyModule;
    exports.ɵi = TreeCellActionsComponent;
    exports.ɵj = CustomCellEditorComponent;
    exports.ɵk = TreeCellEditorComponent;
    exports.ɵh = CustomCellViewComponent;
    exports.ɵg = TreeCellViewComponent;
    exports.ɵf = TreeCellComponent;
    exports.ɵe = TreeCellModule;
    exports.ɵq = TreeHeadComponent;
    exports.ɵp = TreeHeadModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=angular-tree-grid.umd.js.map